diff --git a/sys/sys/rndsource.h b/sys/sys/rndsource.h
index 11e53d632500..345153337e57 100644
--- a/sys/sys/rndsource.h
+++ b/sys/sys/rndsource.h
@@ -1,12 +1,11 @@
 /*	$NetBSD: rndsource.h,v 1.6 2018/04/19 21:19:07 christos Exp $	*/
 
 /*-
- * Copyright (c) 1997 The NetBSD Foundation, Inc.
+ * Copyright (c) 2019 The NetBSD Foundation, Inc.
  * All rights reserved.
  *
  * This code is derived from software contributed to The NetBSD Foundation
- * by Michael Graff <explorer@flame.org>.  This code uses ideas and
- * algorithms from the Linux driver written by Ted Ts'o.
+ * by Taylor R. Campbell.
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
@@ -38,85 +37,43 @@
 #endif
 
 #include <sys/types.h>
-#include <sys/null.h>
-#include <sys/rndio.h>		/* RND_TYPE_*, RND_FLAG_* */
-#include <sys/rngtest.h>
 #include <sys/queue.h>
+#include <sys/rndio.h>
 
-typedef struct rnd_delta_estimator {
-	uint64_t	x;
-	uint64_t	dx;
-	uint64_t	d2x;
-	uint64_t	insamples;
-	uint64_t	outbits;
-} rnd_delta_t;
+struct percpu;
 
-typedef struct krndsource {
-	LIST_ENTRY(krndsource) list;	/* the linked list */
-        char            name[16];       /* device name */
-	rnd_delta_t	time_delta;	/* time delta estimator */
-	rnd_delta_t	value_delta;	/* value delta estimator */
-        uint32_t        total;          /* entropy from this source */
-        uint32_t        type;           /* type */
-        uint32_t        flags;          /* flags */
-        void            *state;         /* state information */
-        size_t          test_cnt;       /* how much test data accumulated? */
-	void		(*get)(size_t, void *);	/* pool wants N bytes (badly) */
-	void		*getarg;	/* argument to get-function */
-	void		(*enable)(struct krndsource *, bool); /* turn on/off */
-	rngtest_t	*test;		/* test data for RNG type sources */
-	unsigned	refcnt;
-} krndsource_t;
-
-static __inline void
-rndsource_setcb(struct krndsource *const rs, void (*const cb)(size_t, void *),
-    void *const arg)
-{
-	rs->get = cb;
-	rs->getarg = arg;
-}
-
-static __inline void
-rndsource_setenable(struct krndsource *const rs, void *const cb)
-{
-	rs->enable = cb;
-}
+/*
+ * struct krndsource
+ *
+ *	State for an entropy source.  To be allocated by a driver for a
+ *	hardware entropy source, and treated as opaque.
+ */
+struct krndsource {
+	LIST_ENTRY(krndsource)	rs_list;	/* entry in list of sources */
+	char			rs_name[16];	/* device name */
+	int			rs_type;	/* type, RND_TYPE_* */
+	int			rs_flags;	/* flags, RND_FLAG_* */
+	struct percpu		*rs_percpu;	/* struct rndsource_cpu */
+	unsigned		rs_nbits_early;	/* bits added while cold */
+	void			(*rs_request)(size_t, void *);
+						/* callback to request more */
+	void			*rs_requestarg;	/* cookie for req. callback */
+};
 
-#define RND_ENABLED(rp) \
-        (((rp)->flags & RND_FLAG_NO_COLLECT) == 0)
+typedef struct krndsource krndsource_t;
 
-void		_rnd_add_uint32(krndsource_t *, uint32_t);
-void		_rnd_add_uint64(krndsource_t *, uint64_t);
-void		rnd_add_data(krndsource_t *, const void *const, uint32_t,
-		    uint32_t);
-void		rnd_add_data_sync(krndsource_t *, const void *, uint32_t,
-		    uint32_t);
-void		rnd_attach_source(krndsource_t *, const char *,
-		    uint32_t, uint32_t);
-void		rnd_detach_source(krndsource_t *);
+void	rndsource_setcb(struct krndsource *, void (*)(size_t, void *), void *);
+void	rnd_attach_source(struct krndsource *, const char *, int, int);
+void	rnd_detach_source(struct krndsource *);
 
-static __inline void
-rnd_add_uint32(krndsource_t *kr, uint32_t val)
-{
-	if (__predict_true(kr)) {
-		if (RND_ENABLED(kr)) {
-			_rnd_add_uint32(kr, val);
-		}
-	} else {
-		rnd_add_data(NULL, &val, sizeof(val), 0);
-	}
-}
+void	rnd_add_uint32(struct krndsource *, uint32_t);
+void	rnd_add_data(struct krndsource *, const void *, uint32_t, uint32_t);
+void	rnd_add_data_sync(struct krndsource *, const void *, uint32_t,
+	    uint32_t);
 
-static __inline void
-rnd_add_uint64(krndsource_t *kr, uint64_t val)
-{
-	if (__predict_true(kr)) {
-		if (RND_ENABLED(kr)) {
-			_rnd_add_uint64(kr, val);
-		}
-	} else {
-		rnd_add_data(NULL, &val, sizeof(val), 0);
-	}
-}
+void	rndsource_disable(struct krndsource *);
+bool	rndsource_disabled(const struct krndsource *);
+const char *
+	rndsource_name(const struct krndsource *);
 
 #endif	/* _SYS_RNDSOURCE_H */
diff --git a/sys/sys/rngtest.h b/sys/sys/rngtest.h
index 1fa70fc05c85..607783e8188b 100644
--- a/sys/sys/rngtest.h
+++ b/sys/sys/rngtest.h
@@ -46,4 +46,11 @@ typedef struct {
 
 int rngtest(rngtest_t *const);
 
+struct rngreptest;
+struct krndsource;
+
+struct rngreptest *rngreptest_create(struct krndsource *, unsigned);
+void rngreptest_destroy(struct rngreptest *);
+void rngreptest_feed(struct rngreptest *, const void *, uint32_t);
+
 #endif
-- 
2.21.0

